
//
// nodes.h
//
// This library handles protos as 'nodes'. Nodes are simple 
// lists with names. They are used by the parser and code generator
//
//
// $Id: nodes.h,v 1.4 2000/12/30 10:39:46 dru Exp $
//
// $Log: nodes.h,v $
// Revision 1.4  2000/12/30 10:39:46  dru
// This is the checkin that has working blocks!
// Plus tons of other fixes!
//
// Revision 1.3  2000/12/22 00:03:17  dru
// This is just a save point. I want to keep what we have.
// Everything compiles, the test8 compiles, but now I'm
// doing the change to the nodes.c data structure so that
// we get around the 256 slot limit.
//
// Revision 1.2  2000/12/07 23:03:17  dru
// Lots and lots of good changes.
// The system is at the point where the parse tree is much
// cleaner. It cannot generate code (again), but with this
// round of work, it should run blocks.
//
// Revision 1.1  2000/09/22 13:05:26  dru
// This is the post-split compiler.  The compiler was split into the node handling
// and the codegen section. The codegen section was cleaned up a lot (there is
// more to do there, I'm sure). I also got the parse/lexer errors to print
// out in a much nicer way.
//
//



#ifndef _BUBL_NODES_H
#define _BUBL_NODES_H 1


Proto createNode(Proto title);

Proto addToNode(Proto node, Proto newItem);

Proto annotateNode(Proto node, Atom name, Proto newItem);

Proto removeFromNode(Proto node, int index);

Proto insertNodeAt(Proto destnode, Proto node, int index);

uint32 nodeCount(Proto obj);

uint32 nodeGet (Proto obj, uint32 index, Proto * dest);

uint32 nodeSet (Proto obj, uint32 index, Proto set);

int isNode(Proto proto);

Proto appendNodeToNode(Proto src, Proto dest);

// void * nodeDump(Proto proto);

void * removeForwards(Proto proto);



#endif


